Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkTransform Class Reference

`#include <vtkTransform.h>`

Inheritance diagram for vtkTransform:

[legend]
Collaboration diagram for vtkTransform:

[legend]
List of all members.

## Detailed Description

describes linear transformations via a 4x4 matrix

Date:
  2003/01/06 20:36:14

Revision:
  1.84

A vtkTransform can be used to describe the full range of linear (also known as affine) coordinate transformations in three dimensions, which are internally represented as a 4x4 homogeneous transformation matrix. When you create a new vtkTransform, it is always initialized to the identity transformation.

The SetInput() method allows you to set another transform, instead of the identity transform, to be the base transformation. There is a pipeline mechanism to ensure that when the input is modified, the current transformation will be updated accordingly. This pipeline mechanism is also supported by the Concatenate() method.

Most of the methods for manipulating this transformation, e.g. Translate, Rotate, and Concatenate, can operate in either PreMultiply (the default) or PostMultiply mode. In PreMultiply mode, the translation, concatenation, etc. will occur before any transformations which are represented by the current matrix. In PostMultiply mode, the additional transformation will occur after any transformations represented by the current matrix.

This class performs all of its operations in a right handed coordinate system with right handed rotations. Some other graphics libraries use left handed coordinate systems and rotations.

See also:
  vtkPerspectiveTransform vtkGeneralTransform vtkMatrix4x4 vtkTransformCollection vtkTransformFilter vtkTransformPolyDataFilter vtkImageReslice

Created by:
  - Lorensen, Bill

CVS contributions (if > 5%):
  - Gobbi, David (38%)
  - Lorensen, Bill (16%)
  - Schroeder, Will (16%)
  - Martin, Ken (12%)
  - Volpe, Christopher (6%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkTransform.cxx)`
  - .`h` (`/Common/vtkTransform.h)`

Examples:
  vtkTransform (Examples)

Tests:
  vtkTransform (Tests)

Definition at line 76 of file vtkTransform.h.

## Public Types
typedef vtkLinearTransform | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | Identity ()
void | Inverse ()
void | Concatenate (vtkLinearTransform *transform)
void | GetInverse (vtkMatrix4x4 *inverse)
void | GetTranspose (vtkMatrix4x4 *transpose)
int | CircuitCheck (vtkAbstractTransform *transform)
vtkAbstractTransform * | GetInverse ()
vtkAbstractTransform * | MakeTransform ()
unsigned long | GetMTime ()
void | Translate (double x, double y, double z)
void | Translate (const double x[3])
void | Translate (const float x[3])
void | RotateWXYZ (double angle, double x, double y, double z)
void | RotateWXYZ (double angle, const double axis[3])
void | RotateWXYZ (double angle, const float axis[3])
void | RotateX (double angle)
void | RotateY (double angle)
void | RotateZ (double angle)
void | Scale (double x, double y, double z)
void | Scale (const double s[3])
void | Scale (const float s[3])
void | SetMatrix (vtkMatrix4x4 *matrix)
void | SetMatrix (const double elements[16])
void | Concatenate (vtkMatrix4x4 *matrix)
void | Concatenate (const double elements[16])
void | PreMultiply ()
void | PostMultiply ()
int | GetNumberOfConcatenatedTransforms ()
vtkLinearTransform * | GetConcatenatedTransform (int i)
void | GetOrientation (double orient[3])
void | GetOrientation (float orient[3])
float * | GetOrientation ()
void | GetOrientationWXYZ (double wxyz[4])
void | GetOrientationWXYZ (float wxyz[3])
float * | GetOrientationWXYZ ()
void | GetPosition (double pos[3])
void | GetPosition (float pos[3])
float * | GetPosition ()
void | GetScale (double scale[3])
void | GetScale (float scale[3])
float * | GetScale ()
void | SetInput (vtkLinearTransform *input)
vtkLinearTransform * | GetInput ()
int | GetInverseFlag ()
void | Push ()
void | Pop ()
void | MultiplyPoint (const float in[4], float out[4])
void | MultiplyPoint (const double in[4], double out[4])
## Static Public Methods
vtkTransform * | New ()
int | IsTypeOf (const char *type)
vtkTransform * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkTransform ()
| ~vtkTransform ()
void | InternalDeepCopy (vtkAbstractTransform *t)
void | InternalUpdate ()
## Protected Attributes
vtkLinearTransform * | Input
vtkTransformConcatenation * | Concatenation
vtkTransformConcatenationStack * | Stack
unsigned long | MatrixUpdateMTime
float | Point [4]
double | DoublePoint [4]
float | ReturnValue [4]

## Member Typedef Documentation

typedef vtkLinearTransform vtkTransform::Superclass

| Reimplemented from vtkLinearTransform. Definition at line 80 of file vtkTransform.h.

## Constructor & Destructor Documentation

vtkTransform::vtkTransform | ( |  | ) | `[protected]`

vtkTransform::~vtkTransform | ( |  | ) | `[protected]`

## Member Function Documentation

vtkTransform* vtkTransform::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkTransform::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkLinearTransform.

int vtkTransform::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkLinearTransform.

virtual int vtkTransform::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkLinearTransform.

vtkTransform* vtkTransform::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkLinearTransform.

void vtkTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkLinearTransform.

void vtkTransform::Identity | ( |  | ) |

| Set the transformation to the identity transformation. If the transform has an Input, then the transformation will be reset so that it is the same as the Input. Reimplemented from vtkAbstractTransform.

void vtkTransform::Inverse | ( |  | ) | `[virtual]`

| Invert the transformation. This will also set a flag so that the transformation will use the inverse of its Input, if an Input has been set. Implements vtkAbstractTransform.

void vtkTransform::Translate | ( | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 96 of file vtkTransform.h.

void vtkTransform::Translate | ( | const double | x[3] | ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 98 of file vtkTransform.h.

void vtkTransform::Translate | ( | const float | x[3] | ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 99 of file vtkTransform.h.

void vtkTransform::RotateWXYZ | ( | double | angle,
|  | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 107 of file vtkTransform.h.

void vtkTransform::RotateWXYZ | ( | double | angle,
|  | const double | axis[3]
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 109 of file vtkTransform.h.

void vtkTransform::RotateWXYZ | ( | double | angle,
|  | const float | axis[3]
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 111 of file vtkTransform.h.

void vtkTransform::RotateX | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 119 of file vtkTransform.h.

void vtkTransform::RotateY | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 120 of file vtkTransform.h.

void vtkTransform::RotateZ | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 121 of file vtkTransform.h.

void vtkTransform::Scale | ( | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 128 of file vtkTransform.h.

void vtkTransform::Scale | ( | const double | s[3] | ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 130 of file vtkTransform.h.

void vtkTransform::Scale | ( | const float | s[3] | ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 131 of file vtkTransform.h.

void vtkTransform::SetMatrix | ( | vtkMatrix4x4 * | matrix | ) | `[inline]`

| Set the current matrix directly. This actually calls Identity(), followed by Concatenate(matrix). Definition at line 137 of file vtkTransform.h. References vtkMatrix4x4::Element.

void vtkTransform::SetMatrix | ( | const double | elements[16] | ) | `[inline]`

| Set the current matrix directly. This actually calls Identity(), followed by Concatenate(matrix). Definition at line 139 of file vtkTransform.h. References vtkAbstractTransform::Identity().

void vtkTransform::Concatenate | ( | vtkMatrix4x4 * | matrix | ) | `[inline]`

| Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 146 of file vtkTransform.h. References vtkMatrix4x4::Element.

void vtkTransform::Concatenate | ( | const double | elements[16] | ) | `[inline]`

| Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 148 of file vtkTransform.h.

void vtkTransform::Concatenate | ( | vtkLinearTransform * | transform | ) |

| Concatenate the specified transform with the current transformation according to PreMultiply or PostMultiply semantics. The concatenation is pipelined, meaning that if any of the transformations are changed, even after Concatenate() is called, those changes will be reflected when you call TransformPoint().

void vtkTransform::PreMultiply | ( |  | ) | `[inline]`

| Sets the internal state of the transform to PreMultiply. All subsequent operations will occur before those already represented in the current transformation. In homogeneous matrix notation, M = M*A where M is the current transformation matrix and A is the applied matrix. The default is PreMultiply. Definition at line 165 of file vtkTransform.h. References vtkObject::Modified().

void vtkTransform::PostMultiply | ( |  | ) | `[inline]`

| Sets the internal state of the transform to PostMultiply. All subsequent operations will occur after those already represented in the current transformation. In homogeneous matrix notation, M = A*M where M is the current transformation matrix and A is the applied matrix. The default is PreMultiply. Definition at line 176 of file vtkTransform.h. References vtkObject::Modified().

int vtkTransform::GetNumberOfConcatenatedTransforms | ( |  | ) | `[inline]`

| Get the total number of transformations that are linked into this one via Concatenate() operations or via SetInput(). Definition at line 184 of file vtkTransform.h.

vtkLinearTransform* vtkTransform::GetConcatenatedTransform | ( | int | i | ) | `[inline]`

| Get one of the concatenated transformations as a vtkAbstractTransform. These transformations are applied, in series, every time the transformation of a coordinate occurs. This method is provided to make it possible to decompose a transformation into its constituents, for example to save a transformation to a file. Definition at line 195 of file vtkTransform.h.

void vtkTransform::GetOrientation | ( | double | orient[3] | ) |

| Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values.

void vtkTransform::GetOrientation | ( | float | orient[3] | ) | `[inline]`

| Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values. Definition at line 212 of file vtkTransform.h.

float* vtkTransform::GetOrientation | ( |  | ) | `[inline]`

| Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values. Definition at line 217 of file vtkTransform.h.

void vtkTransform::GetOrientationWXYZ | ( | double | wxyz[4] | ) |

| Return the wxyz angle+axis representing the current orientation.

void vtkTransform::GetOrientationWXYZ | ( | float | wxyz[3] | ) | `[inline]`

| Return the wxyz angle+axis representing the current orientation. Definition at line 224 of file vtkTransform.h.

float* vtkTransform::GetOrientationWXYZ | ( |  | ) | `[inline]`

| Return the wxyz angle+axis representing the current orientation. Definition at line 230 of file vtkTransform.h.

void vtkTransform::GetPosition | ( | double | pos[3] | ) |

| Return the position from the current transformation matrix as an array of three floating point numbers. This is simply returning the translation component of the 4x4 matrix.

void vtkTransform::GetPosition | ( | float | pos[3] | ) | `[inline]`

| Return the position from the current transformation matrix as an array of three floating point numbers. This is simply returning the translation component of the 4x4 matrix. Definition at line 239 of file vtkTransform.h.

float* vtkTransform::GetPosition | ( |  | ) | `[inline]`

| Return the position from the current transformation matrix as an array of three floating point numbers. This is simply returning the translation component of the 4x4 matrix. Definition at line 244 of file vtkTransform.h.

void vtkTransform::GetScale | ( | double | scale[3] | ) |

| Return the scale factors of the current transformation matrix as an array of three float numbers. These scale factors are not necessarily about the x, y, and z axes unless unless the scale transformation was applied before any rotations.

void vtkTransform::GetScale | ( | float | scale[3] | ) | `[inline]`

| Return the scale factors of the current transformation matrix as an array of three float numbers. These scale factors are not necessarily about the x, y, and z axes unless unless the scale transformation was applied before any rotations. Definition at line 254 of file vtkTransform.h.

float* vtkTransform::GetScale | ( |  | ) | `[inline]`

| Return the scale factors of the current transformation matrix as an array of three float numbers. These scale factors are not necessarily about the x, y, and z axes unless unless the scale transformation was applied before any rotations. Definition at line 259 of file vtkTransform.h.

void vtkTransform::GetInverse | ( | vtkMatrix4x4 * | inverse | ) |

| Return a matrix which is the inverse of the current transformation matrix.

void vtkTransform::GetTranspose | ( | vtkMatrix4x4 * | transpose | ) |

| Return a matrix which is the transpose of the current transformation matrix. This is equivalent to the inverse if and only if the transformation is a pure rotation with no translation or scale.

void vtkTransform::SetInput | ( | vtkLinearTransform * | input | ) |

| Set the input for this transformation. This will be used as the base transformation if it is set. This method allows you to build a transform pipeline: if the input is modified, then this transformation will automatically update accordingly. Note that the InverseFlag, controlled via Inverse(), determines whether this transformation will use the Input or the inverse of the Input.

vtkLinearTransform* vtkTransform::GetInput | ( |  | ) | `[inline]`

| Set the input for this transformation. This will be used as the base transformation if it is set. This method allows you to build a transform pipeline: if the input is modified, then this transformation will automatically update accordingly. Note that the InverseFlag, controlled via Inverse(), determines whether this transformation will use the Input or the inverse of the Input. Definition at line 280 of file vtkTransform.h.

int vtkTransform::GetInverseFlag | ( |  | ) | `[inline]`

| Get the inverse flag of the transformation. This controls whether it is the Input or the inverse of the Input that is used as the base transformation. The InverseFlag is flipped every time Inverse() is called. The InverseFlag is off when a transform is first created. Definition at line 288 of file vtkTransform.h.

void vtkTransform::Push | ( |  | ) | `[inline]`

| Pushes the current transformation onto the transformation stack. Definition at line 294 of file vtkTransform.h. References vtkObject::Modified(), and vtkTransformConcatenationStack::New().

void vtkTransform::Pop | ( |  | ) | `[inline]`

| Deletes the transformation on the top of the stack and sets the top to the next transformation on the stack. Definition at line 303 of file vtkTransform.h. References vtkObject::Modified().

int vtkTransform::CircuitCheck | ( | vtkAbstractTransform * | transform | ) | `[virtual]`

| Check for self-reference. Will return true if concatenating with the specified transform, setting it to be our inverse, or setting it to be our input will create a circular reference. CircuitCheck is automatically called by SetInput(), SetInverse(), and Concatenate(vtkXTransform *). Avoid using this function, it is experimental. Reimplemented from vtkAbstractTransform.

vtkAbstractTransform* vtkTransform::GetInverse | ( |  | ) | `[inline]`

| Get the inverse of this transform. If you modify this transform, the returned inverse transform will automatically update. If you want the inverse of a vtkTransform, you might want to use GetLinearInverse() instead which will type cast the result from vtkAbstractTransform to vtkLinearTransform. Reimplemented from vtkAbstractTransform. Definition at line 318 of file vtkTransform.h. References vtkAbstractTransform::GetInverse().

vtkAbstractTransform* vtkTransform::MakeTransform | ( |  | ) | `[virtual]`

| Make a new transform of the same type. Implements vtkAbstractTransform.

unsigned long vtkTransform::GetMTime | ( |  | ) | `[virtual]`

| Override GetMTime to account for input and concatenation. Reimplemented from vtkAbstractTransform.

void vtkTransform::MultiplyPoint | ( | const float | in[4],
|  | float | out[4]
| ) | `[inline]`

| Use this method only if you wish to compute the transformation in homogeneous (x,y,z,w) coordinates, otherwise use TransformPoint(). This method calls this->GetMatrix()->MultiplyPoint(). Definition at line 331 of file vtkTransform.h. References vtkHomogeneousTransform::GetMatrix(), and vtkMatrix4x4::MultiplyPoint().

void vtkTransform::MultiplyPoint | ( | const double | in[4],
|  | double | out[4]
| ) | `[inline]`

| Use this method only if you wish to compute the transformation in homogeneous (x,y,z,w) coordinates, otherwise use TransformPoint(). This method calls this->GetMatrix()->MultiplyPoint(). Definition at line 333 of file vtkTransform.h. References vtkHomogeneousTransform::GetMatrix(), and vtkMatrix4x4::MultiplyPoint().

void vtkTransform::InternalDeepCopy | ( | vtkAbstractTransform * | t | ) | `[protected, virtual]`

| Perform any subclass-specific DeepCopy. Reimplemented from vtkHomogeneousTransform.

void vtkTransform::InternalUpdate | ( |  | ) | `[protected, virtual]`

| Perform any subclass-specific Update. Reimplemented from vtkAbstractTransform.

## Member Data Documentation

vtkLinearTransform* vtkTransform::Input`[protected]`

| Definition at line 345 of file vtkTransform.h.

vtkTransformConcatenation* vtkTransform::Concatenation`[protected]`

| Definition at line 346 of file vtkTransform.h.

vtkTransformConcatenationStack* vtkTransform::Stack`[protected]`

| Definition at line 347 of file vtkTransform.h.

unsigned long vtkTransform::MatrixUpdateMTime`[protected]`

| Definition at line 351 of file vtkTransform.h.

float vtkTransform::Point[4]`[protected]`

| Definition at line 353 of file vtkTransform.h.

double vtkTransform::DoublePoint[4]`[protected]`

| Definition at line 354 of file vtkTransform.h.

float vtkTransform::ReturnValue[4]`[protected]`

| Definition at line 355 of file vtkTransform.h.

The documentation for this class was generated from the following file:

- Common/vtkTransform.h